using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.IO;
using Nintenlord.GBA.Compressions;

namespace Nintenlord.LZ77_compressor
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            if (args.Length > 0)
            {
                Application.Run(new Form1(args[0]));
            }
            else
            {
                Application.Run(new Form1()); 
            }
        }

        //public enum actions { scan, compress, uncompress, check, lenght, none };
        //Program.Run(originalFile, outputFile, offset, outOffset, size, action, checkBox1.Checked);
        public static bool Compress(string input, string output, int inputOffset, int length, int outputOffset)
        {
            bool returnValue = true;
            BinaryReader br = null;
            BinaryWriter bw = null;
            byte[] array;
            try
            {
                br = new BinaryReader(File.Open(input, FileMode.Open));
                bw = new BinaryWriter(File.Open(output, FileMode.OpenOrCreate));
            }
            catch (IOException)
            {
                returnValue = false;
            }

            if (length == 0)
                length = (int)br.BaseStream.Length;

            array = LZ77.Compress(br, inputOffset, length);
            bw.BaseStream.Position = outputOffset;
            bw.Write(array);

            if (br != null)
                br.Close();
            if (bw != null)
                bw.Close();
            return returnValue;
        }

        public static bool Check(string input, int offset)
        {
            BinaryReader br = new BinaryReader(File.Open(input, FileMode.Open));
            return LZ77.CanBeUnCompressed(br, offset, (int)br.BaseStream.Length - offset);
            br.Close();    
        }

        public static bool Decompress(string input, string output, int inputOffset, int outputOffset)
        {
            bool returnValue = true;
            BinaryReader br = null;
            BinaryWriter bw = null;
            byte[] array;
            try
            {
                br = new BinaryReader(File.Open(input, FileMode.Open));
                bw = new BinaryWriter(File.Open(output, FileMode.OpenOrCreate));
                array = LZ77.Decompress(br, inputOffset);
                bw.BaseStream.Position = outputOffset;
                bw.Write(array);
            }
            catch (Exception)
            {
                returnValue = false;
            }
            finally
            {
                if (br != null)
                    br.Close();
                if (bw != null)
                    bw.Close();
            }
            return returnValue;
        }

        public unsafe static int[] Scan(string path, int offset, int lenght)
        {
            BinaryReader br = new BinaryReader(File.Open(path, FileMode.Open));
            if (lenght == 0 || lenght + offset > br.BaseStream.Length)
                lenght =  (int)br.BaseStream.Length - offset;

            br.BaseStream.Position = offset;
            byte[] file = br.ReadBytes(lenght);

            int[] result;
            fixed (byte* pointer = &file[0])
            {
                result = LZ77.Scan(pointer, lenght);
            }
            return result;
            br.Close();
        }

        public static int Length(string input, int offset)
        {
            int result;
            BinaryReader br = new BinaryReader(File.Open(input, FileMode.Open));
            if (offset > br.BaseStream.Length)
                result = - 1;
            else
                result = LZ77.GetCompressedDataLenght(br, offset);
            br.Close();
            return result;
        }
    }
}

                        //string message = "Data in offset ";
                        //message += "0x" + Convert.ToString(offset, 16);
                        //int lenght;
                        //if (LZ77.GetCompressedDataLenght(br, offset, out lenght))
                        //{
                        //    message += " has the leght of ";
                        //    message += Convert.ToString(lenght, 16) + ".";
                        //}
                        //else
                        //{
                        //    message += " isn't LZ77 compressed.";
                        //}

                            //string line = "Offset 0x" + Convert.ToString(var, 16) + ", uncompressed lenght 0x";
                            //byte[] data = LZ77.UnCompress(br, var);
                            //byte[] compData = LZ77.Compress(data);
                            //line += Convert.ToString(data.Length, 16) + ", compressed lenght 0x" + Convert.ToString(compData.Length, 16) + " and value 0x";
                            //line += Convert.ToString(LZ77.GetCompressedDataLenght(br, var), 16);
                            //sw.WriteLine(line);